# DescribeSubnets

## 1. API Description

This API (DescribeSubnets) is used to query the details of subnets. You can filter the query results with the subnet ID or name.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name   | Required | Type            | Description                                                                                                                          |
| ---------------- | -------- | --------------- | ------------------------------------------------------------------------------------------------------------------------------------ |
| subnetIds        | No       | Array of String | Subnet ID(s).                                                                                                                        |
| name             | No       | String          | Subnet name. Fuzzy query is supported.                                                                                               |
| cidrBlock        | No       | String          | <p>CIDR block of the subnet.</p><p>Fuzzy query is supported.</p>                                                                     |
| regionId         | No       | String          | Region ID of the subnet.                                                                                                             |
| pageSize         | No       | Integer         | <p>Number of items in the current page result.</p><p>Default value: 20;</p><p>Maximum value: 1000.</p><p>Value range: \[1, 1000]</p> |
| pageNum          | No       | Integer         | <p>Number of pages returned.</p><p>Value range: \[1, +)</p><p>Default value: 1</p>                                                   |
| vpcIds           | No       | Array of String | ID list of global VPCs.                                                                                                              |
| dhcpOptionsSetId | No       | String          | ID of the associated DHCP options set.                                                                                               |

## 3. Output Parameters

| Parameter Name | Type                                                                          | Description                                                                                                           |
| -------------- | ----------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String                                                                        | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| totalCount     | Integer                                                                       | Number of subnets meeting the filtering conditions.                                                                   |
| dataSet        | Array of [SubnetInfo](/api-reference/compute/zec/datastructure.md#subnetinfo) | Information on a subnet.                                                                                              |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Query all the available subnets with a CIDR block of `10.0.0.0/24`.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeSubnets
<Common Request Params>

Request:
{
  "cidrBlock": "10.0.0.0/24",
  "pageSize": 10,
  "pageNum": 1
}

Response:
{
  "requestId": "TBFC01FCF-6439-4530-ADBC-16809F0C3E8F",
  "response": {
    "requestId": "TBFC01FCF-6439-4530-ADBC-16809F0C3E8F",
    "dataSet": [
      {
        "subnetId": "<subnetId>",
        "regionid": "asia-east-1",
        "name": "Test",
        "cidrBlock": "10.0.0.0/24",
        "gatewayIpAddress": "10.0.0.1",
        "ipv6GatewayIpAddress": "2001:2:0:xx::1",
        "ipv6CidrBlock": "2001:2:0:xx::/64",
        "stackType": "IPv4_IPv6",
        "ipv6Type": "Public",
        "vpcId": "<vpcId>",
        "vpcName": "Test",
        "usageIpv4Count": 253,
        "usageIpv6Count": 1,
        "createTime": "2022-01-01T01:00:00Z",
        "isDefault": true,
        "dhcpOptionsSetId": null
      }
    ],
    "totalCount": 1
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.console.zenlayer.com/api-reference/compute/zec/vpc-network/describesubnets.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
